# OOX

The name ”OOX” is a mutually recursive acronym: “OOX” stands for “**O**OX **O**r **X**OO”, while “XOO” stands for “**X**OO **O**r **O**OX”. Other than that this is your typical [Tic‐tac‐toe game](https://en.wikipedia.org/wiki/Tic-tac-toe), used as a training ground to explore the development of games in Rust.

![OOX in action](/demo.png)

## Usage

### Requirements

Rust must be installed on your system; the oldest supported version is `1.63.0`. No other dependencies are required.

### Installing

Clone this repository locally:

```shell
$ git clone https://forge.thatspaceandtime.org/ooxie/oox.git
$ cd oox
```

### Building

To build the binary, execute:

```shell
$ cargo build --release
```

### Running

To run the game, either execute (this will also build if need be):

```shell
$ cargo run --release
```

or:

```shell
$ ./target/release/oox
```

### Playing

SETUP: This game is for two players. Player 1 plays with marks noted ”X” and Player 2 with marks noted ”O”. The board consists of 3 rows and 3 columns, and is empty at the start of the game.

GOAL: Each player tries to align three of their marks on the board.

GAMEPLAY: Each player takes their turn alternatively, starting with Player 1. Each turn a player must place one mark on one of the free spaces of the board; they do this by entering the coordinates of the desired space (for example ”a1”).

END OF GAME: If one player succeeds in aligning three of their marks, either horizontally, vertically, or diagonally, they win the game. If no player is able to do so by the time the board is full, the game is declared a draw.

## License

The source code of this project is licensed under a [GNU General Public License v3.0](/LICENSE).
